import java.util.List;
import java.util.LinkedList;
import java.io.PrintStream;
import java.lang.StringBuilder;

import org.antlr.v4.runtime.ParserRuleContext;
import org.antlr.v4.runtime.Token;
import org.antlr.v4.runtime.tree.ParseTreeProperty;
import org.antlr.v4.runtime.tree.TerminalNode;

public class ClassCodeGen extends CodeGen {
  public ClassCodeGen(Scope scope) {
    super(scope);
  }

  private String mangleDefName(String className, String defName) {
    return String.format("_%s_%s", className, defName);
  }
  
  @Override
  public String visitClassDef(GrammarParser.ClassDefContext ctx) {
    StringBuilder sb = new StringBuilder();
    return sb.toString();
  }

  @Override
  public String visitClassImpl(GrammarParser.ClassImplContext classctx) {
    StringBuilder sb = new StringBuilder();
    return sb.toString();
  }

  @Override
  public String visitInit(GrammarParser.InitContext ctx) {
    StringBuilder sb = new StringBuilder();
    return sb.toString();
  }

  @Override
  public String visitDelete(GrammarParser.DeleteContext ctx) {
    StringBuilder sb = new StringBuilder();
    return sb.toString();
  }

  @Override
  public String visitCall(GrammarParser.CallContext ctx) {
    StringBuilder sb = new StringBuilder();
    return sb.toString();
  }

  @Override
  public String visitQualified(GrammarParser.QualifiedContext ctx) {
    StringBuilder sb = new StringBuilder();
    return sb.toString();
  }  

  /** Print informational messages at a specific file, line, and column. */
  public static void info(ParserRuleContext ctx, String msg) {
    Token firstToken = ctx.getStart();
    String file = firstToken.getTokenSource().getSourceName();
    int line = firstToken.getLine();
    int col = firstToken.getCharPositionInLine() + 1;
    System.err.println(String.format("[INFO] %s:%d:%d %s", file, line, col, msg));
  }
}
