grammar Grammar;

import SimpleC;

toplevel:         classDef | classImpl | decl | def ;  // UPDATED

classDef:         'class' ID '{' decl* '}' ;  // NEW

classImpl:        'impl' ID '{' def* '}' ;  // NEW

type:             'int' # IntType
                | 'bool' # BoolType
                | 'string' # StringType
                | '(' paramTypes? ')' '->' returnType=type # FunType
                | 'class' ID # ClassType  // NEW
                ;

stmt:             name '=' expr ';' # Assignment
                | 'while' '(' expr ')' stmt # While
                // resolve dangling-else by attempting to match ifthenelse first first
                | 'if'    '(' expr ')' stmt 'else' stmt # IfThenElse
                | 'if'    '(' expr ')' stmt # IfThen
                | 'return' expr ';' # Return
                | expr ';' # ExprStmt
                | ';' # Empty
                | '{' stmt* '}' # Compound
                | 'init' ID ';' # Init  // NEW
                | 'delete' ID ';' # Delete  // NEW
                ;

name:             ID # Simple
                | name '.' ID # Qualified  // NEW
                ;
